/*
  ALARM alle 1 Sekunden mittels IRealTimers und manueller Aktivierung des Timers mittels alarm().
  Nachteil gegenüber einmaligem Intervall Setup: einige µs gehen bei jedem "nachstellen" des Int.
  in catchAlarm() verloren.
 */

#include <stdio.h>
#include <signal.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/time.h>

volatile sig_atomic_t keep_going = 1;
struct timeval tv;
int uOffset;

void exitHandler(int sig)
{
  keep_going = 0;
}

void catchAlarm (int sig)
{
  if(keep_going)
    alarm(1);
  gettimeofday(&tv, NULL); //Get current time

  printf("Hello World at %d seconds and %d microseconds! us between: %d microseconds!\n", 
(int)tv.tv_sec, (int)tv.tv_usec, (int)tv.tv_usec - uOffset);
  uOffset = (int)tv.tv_usec;
}


int main(void)
{
  keep_going = 1;
  uOffset = 0;

  signal(SIGINT, exitHandler);
  signal(SIGALRM, catchAlarm);
  alarm(1);
  while(keep_going);
}
